using System.Linq;
using System.Threading.Tasks;
using DeukBot4.APIHandlers;
using DeukBot4.Utilities;
using Discord.WebSocket;

namespace DeukBot4.MessageHandlers.JokeHandling
{
    internal class DeltaJoke : IJokeController
    {
        public string Id => "delta";
        public string Name => "No deltas, it's called Origin";
        public async Task Run(SocketMessage message)
        {
            var lowerCasedContent = message.Content.ToLowerInvariant().RemoveSpecialCharacters();
            if (lowerCasedContent.Contains("origin"))
                return;

            var lowerSplit = lowerCasedContent.Split(' ');
            if (lowerSplit.Select(s => Lehvenstein.LevenshteinDistance(s, "delta")).Any(diff => diff <= 1))
            {
                var warning = "uhh excuse me it's called\n Origin and it's an art";
                await message.Channel.SendFileAsync(await CatPicHandler.GetCatPicture(warning), "cat_pic.png");
            }
        }
    }
}